Index: /trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90
===================================================================
--- /trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90	(revision 3194)
+++ /trunk/LMDZ.PLUTO/libf/phypluto/physiq_mod.F90	(revision 3195)
@@ -1,8 +1,8 @@
       module physiq_mod
-      
+
       implicit none
-      
+
       contains
-      
+
       subroutine physiq(ngrid,nlayer,nq,   &
                   firstcall,lastcall,      &
@@ -14,7 +14,7 @@
 
 !!
-      use write_field_phy, only: Writefield_phy  
+      use write_field_phy, only: Writefield_phy
 !!
-      use ioipsl_getin_p_mod, only: getin_p 
+      use ioipsl_getin_p_mod, only: getin_p
       use radinc_h, only : L_NSPECTI,L_NSPECTV,naerkind, corrkdir, banddir
       use generic_cloud_common_h, only : epsi_generic, Psat_generic
@@ -23,6 +23,6 @@
       use radcommon_h, only: sigma, glat, grav, BWNV, WNOI, DWNI, DWNV, WNOV
       use suaer_corrk_mod, only: suaer_corrk
-      use radii_mod, only: n2_reffrad
-      use aerosol_mod, only: iniaerosol, iaero_n2 
+      use radii_mod, only: su_aer_radii,haze_reffrad_fix
+      use aerosol_mod, only: iaero_haze, i_haze, haze_prof
       use surfdat_h, only: phisfi, zmea, zstd, zsig, zgam, zthe, &
                            dryness
@@ -33,7 +33,7 @@
       USE comgeomfi_h, only: totarea, totarea_planet
       USE tracer_h, only: noms, mmol, radius, rho_q, qext, &
+                          igcm_n2,&
                           alpha_lift, alpha_devil, qextrhor, &
-                          igcm_dustbin, &
-                          igcm_n2_ice, nesp, is_chim, is_condensable,constants_epsi_generic
+                          nesp, is_chim, is_condensable,constants_epsi_generic
       use time_phylmdz_mod, only: ecritphy, iphysiq, nday
       use phyetat0_mod, only: phyetat0
@@ -48,10 +48,11 @@
       use callkeys_mod, only: albedo_spectral_mode, calladj, calldifv, &
                               callrad, callsoil, nosurf, &
-                              n2cond, corrk, diagdtau, &
+                              aerohaze, corrk, diagdtau,&
                               diurnal, enertest, fat1au, &
                               icetstep, intheat, iradia, kastprof, &
                               lwrite, mass_redistrib, meanOLR, &
-                              nearn2cond, noseason_day, &
+                              n2cond,nearn2cond, noseason_day, &
                               season, sedimentation,generic_condensation, &
+                              aerohaze, haze_proffix, &
                               specOLR, &
                               startphy_file, testradtimes, &
@@ -67,5 +68,5 @@
       use turb_mod, only : q2,sensibFlux,turb_resolved
       use mass_redistribution_mod, only: mass_redistribution
-      use condensation_generic_mod, only: condensation_generic 
+      use condensation_generic_mod, only: condensation_generic
       use datafile_mod, only: datadir
 #ifndef MESOSCALE
@@ -85,5 +86,5 @@
 #endif
 
-#ifdef CPP_XIOS      
+#ifdef CPP_XIOS
       use xios_output_mod, only: initialize_xios_output, &
                                  update_xios_timestep, &
@@ -96,5 +97,5 @@
 
 !==================================================================
-!     
+!
 !     Purpose
 !     -------
@@ -186,15 +187,15 @@
 !           Frederic Hourdin        15/10/93
 !           Francois Forget        1994
-!           Christophe Hourdin        02/1997 
+!           Christophe Hourdin        02/1997
 !           Subroutine completely rewritten by F. Forget (01/2000)
 !           Water ice clouds: Franck Montmessin (update 06/2003)
 !           Radiatively active tracers: J.-B. Madeleine (10/2008-06/2009)
 !           New correlated-k radiative scheme: R. Wordsworth (2009)
-!           Many specifically Martian subroutines removed: R. Wordsworth (2009)       
+!           Many specifically Martian subroutines removed: R. Wordsworth (2009)
 !           Improved water cycle: R. Wordsworth / B. Charnay (2010)
 !           To F90: R. Wordsworth (2010)
 !           New turbulent diffusion scheme: J. Leconte (2012)
 !           Loops converted to F90 matrix format: J. Leconte (2012)
-!           No more ngridmx/nqmx, F90 commons and adaptation to parallel: A. Spiga (2012)
+!           No more ngrid/nq, F90 commons and adaptation to parallel: A. Spiga (2012)
 !           Purge of the code : M. Turbet (2015)
 !           Photochemical core developped by F. Lefevre: B. Charnay (2017)
@@ -217,8 +218,8 @@
       integer,intent(in) :: nlayer            ! Number of atmospheric layers.
       integer,intent(in) :: nq                ! Number of tracers.
-      
+
       logical,intent(in) :: firstcall ! Signals first call to physics.
       logical,intent(in) :: lastcall  ! Signals last call to physics.
-      
+
       real,intent(in) :: pday                  ! Number of elapsed sols since reference Ls=0.
       real,intent(in) :: ptime                 ! "Universal time", given as fraction of sol (e.g.: 0.5 for noon).
@@ -253,5 +254,5 @@
 ! -----------------
 
-!     Aerosol (dust or ice) extinction optical depth  at reference wavelength 
+!     Aerosol (dust or ice) extinction optical depth  at reference wavelength
 !     for the "naerkind" optically active aerosols:
 
@@ -264,5 +265,5 @@
       integer l,ig,ierr,iq,nw,isoil,iesp, igcm_generic_vap, igcm_generic_ice
       logical call_ice_vap_generic ! to call only one time the ice/vap pair of a tracer
-      
+
       real zls                       ! Solar longitude (radians).
       real zlss                      ! Sub solar point longitude (radians).
@@ -272,5 +273,5 @@
 
 ! VARIABLES for the thermal plume model (AF24: deleted)
-      
+
 ! TENDENCIES due to various processes :
 
@@ -281,8 +282,8 @@
       real zdtsdif(ngrid)     ! Turbdiff/vdifc routines.
       ! real zdtsurf_hyd(ngrid) ! Hydrol routine.
-            
-      ! For Atmospheric Temperatures : (K/s)    
+
+      ! For Atmospheric Temperatures : (K/s)
       real dtlscale(ngrid,nlayer)                             ! Largescale routine.
-      real dt_generic_condensation(ngrid,nlayer)              ! condensation_generic routine. 
+      real dt_generic_condensation(ngrid,nlayer)              ! condensation_generic routine.
       real zdtc(ngrid,nlayer)                                 ! Condense_n2 routine.
       real zdtdif(ngrid,nlayer)                               ! Turbdiff/vdifc routines.
@@ -290,12 +291,13 @@
       real zdtsw1(ngrid,nlayer), zdtlw1(ngrid,nlayer)         ! Callcorrk routine.
       real zdtchim(ngrid,nlayer)                              ! Calchim routine.
-                              
+
       ! For Surface Tracers : (kg/m2/s)
       real dqsurf(ngrid,nq)                 ! Cumulated tendencies.
       real zdqsurfc(ngrid)                  ! Condense_n2 routine.
+      REAL zdqsc(ngrid,nq)                  ! Condense_n2 routine.
       real zdqsdif(ngrid,nq)                ! Turbdiff/vdifc routines.
       real zdqssed(ngrid,nq)                ! Callsedim routine.
       real zdqsurfmr(ngrid,nq)              ! Mass_redistribution routine.
-                  
+
       ! For Tracers : (kg/kg_of_air/s)
       real zdqc(ngrid,nlayer,nq)      ! Condense_n2 routine.
@@ -311,7 +313,49 @@
 !$OMP THREADPRIVATE(zdqchim,zdqschim)
 
+
+      !! PLUTO variables
+      REAL zdqch4cloud(ngrid,nlayer,nq)
+      REAL zdqsch4cloud(ngrid,nq)
+      REAL zdtch4cloud(ngrid,nlayer)
+      REAL zdqcocloud(ngrid,nlayer,nq)
+      REAL zdqscocloud(ngrid,nq)
+      REAL zdtcocloud(ngrid,nlayer)
+      REAL rice_ch4(ngrid,nlayer)    ! Methane ice geometric mean radius (m)
+      REAL rice_co(ngrid,nlayer)     ! CO ice geometric mean radius (m)
+
+      REAL zdqsch4fast(ngrid)    ! used only for fast model nogcm
+      REAL zdqch4fast(ngrid)    ! used only for fast model nogcm
+      REAL zdqscofast(ngrid)    ! used only for fast model nogcm
+      REAL zdqcofast(ngrid)    ! used only for fast model nogcm
+      REAL zdqflow(ngrid,nq)
+
+      REAL zdteuv(ngrid,nlayer)    ! (K/s)
+      REAL zdtconduc(ngrid,nlayer) ! (K/s)
+      REAL zdumolvis(ngrid,nlayer)
+      REAL zdvmolvis(ngrid,nlayer)
+      real zdqmoldiff(ngrid,nlayer,nq)
+
+      ! Haze relatated tendancies
+      REAL zdqhaze(ngrid,nlayer,nq)
+      REAL zdqprodhaze(ngrid,nq)
+      REAL zdqsprodhaze(ngrid)
+      REAL zdqhaze_col(ngrid)
+      REAL zdqphot_prec(ngrid,nlayer)
+      REAL zdqphot_ch4(ngrid,nlayer)
+      REAL zdqconv_prec(ngrid,nlayer)
+      REAL zdq_source(ngrid,nlayer,nq)
+      ! Fast Haze relatated tendancies
+      REAL fluxbot(ngrid)
+      REAL gradflux(ngrid)
+      REAL fluxlym_sol_bot(ngrid)      ! Solar flux Lyman alpha ph.m-2.s-1 reaching the surface
+      REAL fluxlym_ipm_bot(ngrid)      ! IPM (Interplanetary) flux Lyman alpha ph.m-2.s-1 reaching the surface
+      REAL flym_sol(ngrid)      ! Incident Solar flux Lyman alpha ph.m-2.s-1
+      REAL flym_ipm(ngrid)      ! Incident IPM (Interplanetary) flux Lyman alpha ph.m-2.s-1
+
+
+
       REAL array_zero1(ngrid)
       REAL array_zero2(ngrid,nlayer)
-                        
+
       ! For Winds : (m/s/s)
       real zdvadj(ngrid,nlayer), zduadj(ngrid,nlayer)       ! Convadj routine.
@@ -320,5 +364,6 @@
       real zdhdif(ngrid,nlayer)                             ! Turbdiff/vdifc routines.
       real zdhadj(ngrid,nlayer)                             ! Convadj routine.
-     
+      REAL zdvc(ngrid,nlayer),zduc(ngrid,nlayer)            ! condense_n2 routine.
+
       ! For Pressure and Mass :
       real zdmassmr(ngrid,nlayer) ! Atmospheric Mass tendency for mass_redistribution (kg_of_air/m2/s).
@@ -326,6 +371,6 @@
       real zdpsrfmr(ngrid)        ! Pressure tendency for mass_redistribution routine (Pa/s).
 
-      
-    
+
+
 ! Local variables for LOCAL CALCULATIONS:
 ! ---------------------------------------
@@ -352,8 +397,24 @@
       real vmr(ngrid,nlayer)                        ! volume mixing ratio
       real time_phys
-      
+
       real ISR,ASR,OLR,GND,DYN,GSR,Ts1,Ts2,Ts3,TsS ! for Diagnostic.
-      
+
       real qcol(ngrid,nq) ! Tracer Column Mass (kg/m2).
+
+      !     Pluto adding variables
+      real vmr_ch4(ngrid)  ! vmr ch4
+      real vmr_co(ngrid)  ! vmr co
+      real rho(ngrid,nlayer) ! density
+      real zrho_ch4(ngrid,nlayer) ! density methane kg.m-3
+      real zrho_co(ngrid,nlayer) ! density CO kg.m-3
+      real zrho_haze(ngrid,nlayer) ! density haze kg.m-3
+      real zdqrho_photprec(ngrid,nlayer) !photolysis rate kg.m-3.s-1
+      real zq1temp_ch4(ngrid) !
+      real qsat_ch4(ngrid) !
+      real qsat_ch4_l1(ngrid) !
+!      CHARACTER(LEN=20) :: txt ! to temporarly store text for eddy tracers
+      real profmmr(ngrid,nlayer) ! fixed profile of haze if haze_proffix
+      real sensiblehf1(ngrid) ! sensible heat flux
+      real sensiblehf2(ngrid) ! sensible heat flux
 
 !     included by RW for H2O Manabe scheme
@@ -367,8 +428,8 @@
       real,save :: dEtotSW, dEtotsSW, dEtotLW, dEtotsLW
 !$OMP THREADPRIVATE(dEtotSW, dEtotsSW, dEtotLW, dEtotsLW)
-      
+
 !JL12 conservation test for mean flow kinetic energy has been disabled temporarily
 
-      real dtmoist_max,dtmoist_min     
+      real dtmoist_max,dtmoist_min
       real dItot, dItot_tmp, dVtot, dVtot_tmp
 
@@ -408,5 +469,5 @@
       real :: flux_sens_lat(ngrid)
       real :: qsurfint(ngrid,nq)
-#ifdef MESOSCALE 
+#ifdef MESOSCALE
       REAL :: lsf_dt(nlayer)
       REAL :: lsf_dq(nlayer)
@@ -416,9 +477,9 @@
       logical, save ::  check_physics_inputs=.false.
       logical, save ::  check_physics_outputs=.false.
-!$OPM THREADPRIVATE(check_physics_inputs,check_physics_outputs)     
+!$OPM THREADPRIVATE(check_physics_inputs,check_physics_outputs)
 
       ! Misc
       character*2 :: str2
-      character(len=10) :: tmp1 
+      character(len=10) :: tmp1
       character(len=10) :: tmp2
 !==================================================================================================
@@ -458,5 +519,5 @@
 !        Initialize aerosol indexes.
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~
-         call iniaerosol
+         ! call iniaerosol
          ! allocate related local arrays
          ! (need be allocated instead of automatic because of "naerkind")
@@ -472,10 +533,10 @@
 !        Read 'startfi.nc' file.
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-#ifndef MESOSCALE 
+#ifndef MESOSCALE
          call phyetat0(startphy_file,                                 &
                        ngrid,nlayer,"startfi.nc",0,0,nsoilmx,nq,      &
                        day_ini,time_phys,tsurf,tsoil,emis,q2,qsurf)
-                       
-#else   
+
+#else
 
          day_ini = pday
@@ -505,5 +566,5 @@
          write (*,*) 'In physiq day_ini =', day_ini
 
-!        Initialize albedo calculation. 
+!        Initialize albedo calculation.
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          albedo(:,:)=0.0
@@ -511,7 +572,7 @@
          albedo_snow_SPECTV(:)=0.0
          albedo_n2_ice_SPECTV(:)=0.0
-         call surfini(ngrid,nq,qsurf,albedo,albedo_bareground,albedo_snow_SPECTV,albedo_n2_ice_SPECTV) 
-
-!        Initialize orbital calculation. 
+         call surfini(ngrid,nq,qsurf,albedo,albedo_bareground,albedo_snow_SPECTV,albedo_n2_ice_SPECTV)
+
+!        Initialize orbital calculation.
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          call iniorbit(apoastr,periastr,year_day,peri_day,obliquit)
@@ -555,7 +616,7 @@
          endif
 
-         if(meanOLR)then          
-            call system('rm -f rad_bal.out') ! to record global radiative balance.           
-            call system('rm -f tem_bal.out') ! to record global mean/max/min temperatures.            
+         if(meanOLR)then
+            call system('rm -f rad_bal.out') ! to record global radiative balance.
+            call system('rm -f tem_bal.out') ! to record global mean/max/min temperatures.
             call system('rm -f h2o_bal.out') ! to record global hydrological balance.
          endif
@@ -563,13 +624,13 @@
 
          !! Initialize variables for water cycle ! AF24: removed
-            
+
 !        Set metallicity for GCS
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
          metallicity=0.0 ! default value --- is not used here but necessary to call function Psat_generic
          call getin_p("metallicity",metallicity) ! --- is not used here but necessary to call function Psat_generic
-         
+
 !        Set some parameters for the thermal plume model !AF24: removed
 !        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-         
+
 #ifndef MESOSCALE
          if (ngrid.ne.1) then ! Note : no need to create a restart file in 1d.
@@ -580,8 +641,8 @@
 
 !!         call WriteField_phy("post_physdem_qsurf",qsurf(1:ngrid,igcm_h2o_vap),1)
-#endif         
-         if (corrk) then 
-            ! We initialise the spectral grid here instead of 
-            ! at firstcall of callcorrk so we can output XspecIR, XspecVI 
+#endif
+         if (corrk) then
+            ! We initialise the spectral grid here instead of
+            ! at firstcall of callcorrk so we can output XspecIR, XspecVI
             ! when using Dynamico
             print*, "physiq_mod: Correlated-k data base folder:",trim(datadir)
@@ -595,5 +656,7 @@
             call setspv ! Basic visible properties.
             call sugas_corrk       ! Set up gaseous absorption properties.
-            call suaer_corrk       ! Set up aerosol optical properties.
+            if (aerohaze) then
+               call suaer_corrk       ! Set up aerosol optical properties.
+            endif
          endif
 
@@ -606,5 +669,5 @@
                                      year_day,presnivs,pseudoalt,WNOI,WNOV)
 #endif
-         
+
 !!         call WriteField_phy("post_xios_qsurf",qsurf(1:ngrid,igcm_h2o_vap),1)
 
@@ -613,5 +676,5 @@
 
 !!      call WriteField_phy("post_firstcall_qsurf",qsurf(1:ngrid,igcm_h2o_vap),1)
-!!      call writediagfi(ngrid,"firstcall_post_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))  
+!!      call writediagfi(ngrid,"firstcall_post_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))
 
       if (check_physics_inputs) then
@@ -627,15 +690,15 @@
 ! ------------------------------------------------------
 
-#ifdef CPP_XIOS      
+#ifdef CPP_XIOS
       ! update XIOS time/calendar
       call update_xios_timestep
-#endif      
+#endif
 
       ! Initialize various variables
       ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-      
+
       if ( .not.nearn2cond ) then
          pdt(1:ngrid,1:nlayer) = 0.0
-      endif      
+      endif
       zdtsurf(1:ngrid)      = 0.0
       pdq(1:ngrid,1:nlayer,1:nq) = 0.0
@@ -644,5 +707,5 @@
       pdv(1:ngrid,1:nlayer) = 0.0
       pdpsrf(1:ngrid)       = 0.0
-      zflubid(1:ngrid)      = 0.0      
+      zflubid(1:ngrid)      = 0.0
       flux_sens_lat(1:ngrid) = 0.0
       taux(1:ngrid) = 0.0
@@ -660,10 +723,10 @@
 
       call orbite(zls,dist_star,declin,right_ascen)
-      
+
       if (diurnal) then
               zlss=-2.*pi*(zday-.5)
       else if(diurnal .eqv. .false.) then
               zlss=9999.
-      endif 
+      endif
 
 
@@ -673,5 +736,5 @@
       ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
       zzlay(1:ngrid,1:nlayer)=pphi(1:ngrid,1:nlayer)
-      do l=1,nlayer         
+      do l=1,nlayer
          zzlay(1:ngrid,l)= zzlay(1:ngrid,l)/glat(1:ngrid)
       enddo
@@ -685,8 +748,8 @@
             zzlev(ig,l)=(z1*zzlay(ig,l-1)+z2*zzlay(ig,l))/(z1+z2)
          enddo
-      enddo     
+      enddo
 
       !Altitude of top interface (nlayer+1), using the thicknesss of the level below the top one. LT22
-      
+
       zzlev(1:ngrid,nlayer+1) = 2*zzlev(1:ngrid,nlayer)-zzlev(1:ngrid,nlayer-1)
 
@@ -694,5 +757,5 @@
       ! Note : Potential temperature calculation may not be the same in physiq and dynamic...
       ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-      do l=1,nlayer         
+      do l=1,nlayer
          do ig=1,ngrid
             zpopsk(ig,l)=(pplay(ig,l)/pplev(ig,1))**rcp
@@ -745,17 +808,17 @@
          endif
 
-      endif 
+      endif
 
       if (callrad) then
          if( mod(icount-1,iradia).eq.0.or.lastcall) then
-           
+
             ! Eclipse incoming sunlight !AF24: removed
 
 !!            call writediagfi(ngrid,"corrk_pre_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
-!!            call writediagfi(ngrid,"corrk_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap)) 
+!!            call writediagfi(ngrid,"corrk_pre_qsurf"," "," ",2,qsurf(1:ngrid,igcm_h2o_vap))
 
 
             if (corrk) then
-            
+
 ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ! II.a Call correlated-k radiative transfer scheme
@@ -766,27 +829,27 @@
                endif
                ! if(water) then !AF24: removed
-               
+
                if(generic_condensation) then
                   do iq=1,nq
 
                      call generic_tracer_index(nq,iq,igcm_generic_vap,igcm_generic_ice,call_ice_vap_generic)
-                     
+
                      if (call_ice_vap_generic) then ! to call only one time the ice/vap pair of a tracer
 
                         epsi_generic=constants_epsi_generic(iq)
 
-                        muvar(1:ngrid,1:nlayer)=mugaz/(1.e0+(1.e0/epsi_generic-1.e0)*pq(1:ngrid,1:nlayer,igcm_generic_vap)) 
-                        muvar(1:ngrid,nlayer+1)=mugaz/(1.e0+(1.e0/epsi_generic-1.e0)*pq(1:ngrid,nlayer,igcm_generic_vap))  
+                        muvar(1:ngrid,1:nlayer)=mugaz/(1.e0+(1.e0/epsi_generic-1.e0)*pq(1:ngrid,1:nlayer,igcm_generic_vap))
+                        muvar(1:ngrid,nlayer+1)=mugaz/(1.e0+(1.e0/epsi_generic-1.e0)*pq(1:ngrid,nlayer,igcm_generic_vap))
 
                      endif
-                  end do ! do iq=1,nq loop on tracers 
+                  end do ! do iq=1,nq loop on tracers
                ! take into account generic condensable specie (GCS) effect on mean molecular weight
-               
+
                else
                   muvar(1:ngrid,1:nlayer+1)=mugaz
-               endif 
-      
+               endif
+
                ! if(ok_slab_ocean) then !AF24: removed
-               
+
                ! standard callcorrk
                ! clearsky=.false.
@@ -799,13 +862,13 @@
                               int_dtaui,int_dtauv,                                &
                               tau_col,cloudfrac,totcloudfrac,                     &
-                              .false.,firstcall,lastcall)     
+                              .false.,firstcall,lastcall)
 
                 !GG (feb2021): Option to "artificially" decrease the raditive time scale in
                 !the deep atmosphere  press > 0.1 bar. Suggested by MT.
-                !! COEFF_RAD to be "tuned" to facilitate convergence of tendency 
-        
+                !! COEFF_RAD to be "tuned" to facilitate convergence of tendency
+
                 !coeff_rad=0.   ! 0 values, it doesn't accelerate the convergence
                 !coeff_rad=0.5
-                !coeff_rad=1.                 
+                !coeff_rad=1.
                 !do l=1, nlayer
                 !  do ig=1,ngrid
@@ -836,6 +899,6 @@
                ! Net atmospheric radiative heating rate (K.s-1)
                dtrad(1:ngrid,1:nlayer)=zdtsw(1:ngrid,1:nlayer)+zdtlw(1:ngrid,1:nlayer)
-               
-               ! Late initialization of the Ice Spectral Albedo. We needed the visible bands to do that ! 
+
+               ! Late initialization of the Ice Spectral Albedo. We needed the visible bands to do that !
                if (firstcall .and. albedo_spectral_mode) then
                   call spectral_albedo_calc(albedo_snow_SPECTV)
@@ -847,5 +910,5 @@
             else
 ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-! II.c Atmosphere has no radiative effect 
+! II.c Atmosphere has no radiative effect
 ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                fluxtop_dn(1:ngrid)  = fract(1:ngrid)*mu0(1:ngrid)*Fat1AU/dist_star**2
@@ -856,6 +919,6 @@
                print*,'------------WARNING---WARNING------------' ! by MT2015.
                print*,'You are in corrk=false mode, '
-               print*,'and the surface albedo is taken equal to the first visible spectral value'               
-               
+               print*,'and the surface albedo is taken equal to the first visible spectral value'
+
                fluxsurfabs_sw(1:ngrid) = fluxtop_dn(1:ngrid)*(1.-albedo(1:ngrid,1))
                fluxrad_sky(1:ngrid)    = fluxsurfabs_sw(1:ngrid)
@@ -867,5 +930,5 @@
 
          endif ! of if(mod(icount-1,iradia).eq.0)
-       
+
 
          ! Transformation of the radiative tendencies
@@ -875,5 +938,5 @@
          fluxrad(1:ngrid)=fluxrad_sky(1:ngrid)-zplanck(1:ngrid)
          pdt(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)+dtrad(1:ngrid,1:nlayer)
-         
+
          ! Test of energy conservation
          !----------------------------
@@ -908,10 +971,10 @@
 
       if (calldifv) then
-      
+
          zflubid(1:ngrid)=fluxrad(1:ngrid)+fluxgrd(1:ngrid)
 
          ! JL12 the following if test is temporarily there to allow us to compare the old vdifc with turbdiff.
          if (UseTurbDiff) then
-         
+
             call turbdiff(ngrid,nlayer,nq,                  &
                           ptimestep,capcal,                      &
@@ -924,7 +987,7 @@
 
          else
-         
+
             zdh(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)/zpopsk(1:ngrid,1:nlayer)
- 
+
             call vdifc(ngrid,nlayer,nq,zpopsk,           &
                        ptimestep,capcal,lwrite,               &
@@ -955,5 +1018,5 @@
 !!         call writediagfi(ngrid,"vdifc_post_zdqsdif"," "," ",2,zdqsdif(1:ngrid,igcm_h2o_vap))
 
-         if (tracer) then 
+         if (tracer) then
            pdq(1:ngrid,1:nlayer,1:nq)=pdq(1:ngrid,1:nlayer,1:nq)+ zdqdif(1:ngrid,1:nlayer,1:nq)
            dqsurf(1:ngrid,1:nq)=dqsurf(1:ngrid,1:nq) + zdqsdif(1:ngrid,1:nq)
@@ -966,5 +1029,5 @@
          !-------------------------
          if(enertest)then
-         
+
             dEzdiff(:,:)=cpp*mass(:,:)*zdtdif(:,:)
             do ig = 1, ngrid
@@ -972,12 +1035,12 @@
                dEzdiff(ig,1)= dEzdiff(ig,1)+ sensibFlux(ig)! subtract flux to the ground
             enddo
-            
+
             call planetwide_sumval(dEdiff(:)*cell_area(:)/totarea_planet,dEtot)
             dEdiffs(:)=capcal(:)*zdtsdif(:)-zflubid(:)-sensibFlux(:)
             call planetwide_sumval(dEdiffs(:)*cell_area(:)/totarea_planet,dEtots)
             call planetwide_sumval(sensibFlux(:)*cell_area(:)/totarea_planet,AtmToSurf_TurbFlux)
-            
+
             if (is_master) then
-            
+
                if (UseTurbDiff) then
                          print*,'In TurbDiff sensible flux (atm=>surf) =',AtmToSurf_TurbFlux,' W m-2'
@@ -990,5 +1053,5 @@
                end if
             endif ! end of 'is_master'
-            
+
          ! JL12 : note that the black body radiative flux emitted by the surface has been updated by the implicit scheme but not given back elsewhere.
          endif ! end of 'enertest'
@@ -1008,9 +1071,9 @@
 !   IV. Convection :
 !-------------------
-      
+
 ! ~~~~~~~~~~~~~~~~~~~~~~~~~~
 ! IV.a Thermal plume model : AF24: removed
 ! ~~~~~~~~~~~~~~~~~~~~~~~~~~
-      
+
 ! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ! IV.b Dry convective adjustment :
@@ -1037,6 +1100,6 @@
          zdtadj(1:ngrid,1:nlayer) = zdhadj(1:ngrid,1:nlayer)*zpopsk(1:ngrid,1:nlayer) ! for diagnostic only
 
-         if(tracer) then 
-            pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqadj(1:ngrid,1:nlayer,1:nq) 
+         if(tracer) then
+            pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqadj(1:ngrid,1:nlayer,1:nq)
          end if
 
@@ -1048,26 +1111,27 @@
 
          ! ! Test water conservation !AF24: removed
-         
+
       endif ! end of 'calladj'
 !----------------------------------------------
 !   Non orographic Gravity Waves: AF24: removed
 !---------------------------------------------
-      
+
 !-----------------------------------------------
-!   V. Carbon dioxide condensation-sublimation :
+!   V. Nitrogen condensation-sublimation :
 !-----------------------------------------------
 
       if (n2cond) then
-      
+
          if (.not.tracer) then
             print*,'We need a N2 ice tracer to condense N2'
             call abort
          endif
+
          call condense_n2(ngrid,nlayer,nq,ptimestep,                    &
-                           capcal,pplay,pplev,tsurf,pt,                  &
-                           pdt,zdtsurf,pq,pdq,                           &
-                           qsurf,zdqsurfc,albedo,emis,                   &
-                           albedo_bareground,albedo_n2_ice_SPECTV,      &
-                           zdtc,zdtsurfc,pdpsrf,zdqc)
+                           capcal,pplay,pplev,tsurf,pt,                 &
+                           pphi,pdt,pdu,pdv,zdtsurf,pu,pv,pq,pdq,       &
+                           qsurf(1,igcm_n2),albedo,emis,                &
+                           zdtc,zdtsurfc,pdpsrf,zduc,zdvc,              &
+                           zdqc,zdqsc(1,igcm_n2))
 
          pdt(1:ngrid,1:nlayer) = pdt(1:ngrid,1:nlayer)+zdtc(1:ngrid,1:nlayer)
@@ -1075,5 +1139,5 @@
 
          pdq(1:ngrid,1:nlayer,1:nq)   = pdq(1:ngrid,1:nlayer,1:nq)+ zdqc(1:ngrid,1:nlayer,1:nq)
-         dqsurf(1:ngrid,igcm_n2_ice) = dqsurf(1:ngrid,igcm_n2_ice) + zdqsurfc(1:ngrid)
+         ! dqsurf(1:ngrid,igcm_n2_ice) = dqsurf(1:ngrid,igcm_n2_ice) + zdqsurfc(1:ngrid)
 
 !!         call writediagfi(ngrid,"condense_n2_post_dqsurf"," "," ",2,dqsurf(1:ngrid,igcm_h2o_vap))
@@ -1094,9 +1158,9 @@
 
 !---------------------------------------------
-!   VI. Specific parameterizations for tracers 
+!   VI. Specific parameterizations for tracers
 !---------------------------------------------
 
       if (tracer) then
-      
+
   ! ---------------------
   !   VI.1. Water and ice !AF24: removed
@@ -1110,5 +1174,5 @@
 
          !Generic Condensation
-         if (generic_condensation) then 
+         if (generic_condensation) then
             call condensation_generic(ngrid,nlayer,nq,ptimestep,pplev,pplay,   &
                                           pt,pq,pdt,pdq,dt_generic_condensation, &
@@ -1128,5 +1192,5 @@
             end if
 
-            ! if (.not. water) then 
+            ! if (.not. water) then
                ! Compute GCS (Generic Condensable Specie) cloud fraction. For now we can not have both water cloud fraction and GCS cloud fraction
                ! Water is the priority
@@ -1150,5 +1214,5 @@
                      enddo
                   endif
-            end do ! do iq=1,nq loop on tracers 
+            end do ! do iq=1,nq loop on tracers
             ! endif ! .not. water
 
@@ -1164,5 +1228,5 @@
 
             ! if(watertest)then !AF24: removed
-           
+
             call callsedim(ngrid,nlayer,ptimestep,           &
                           pplev,zzlev,pt,pdt,pq,pdq,        &
@@ -1170,5 +1234,5 @@
 
             ! if(watertest)then !AF24: removed
-            
+
             ! Whether it falls as rain or snow depends only on the surface temperature
             pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqsed(1:ngrid,1:nlayer,1:nq)
@@ -1178,5 +1242,5 @@
 
             ! ! Test water conservation !AF24: removed
-            
+
          end if ! end of 'sedimentation'
 
@@ -1200,5 +1264,5 @@
                zdmassmr_col(ig)=SUM(zdmassmr(ig,1:nlayer))
             enddo
-            
+
             ! call writediagfi(ngrid,"mass_evap","mass gain"," ",3,zdmassmr)
             ! call writediagfi(ngrid,"mass_evap_col","mass gain col"," ",2,zdmassmr_col)
@@ -1209,5 +1273,5 @@
                                      pu,pv,pdt,zdtsurf,pdq,pdu,pdv,zdmassmr,        &
                                      zdtmr,zdtsurfmr,zdpsrfmr,zdumr,zdvmr,zdqmr,zdqsurfmr)
-         
+
             pdq(1:ngrid,1:nlayer,1:nq) = pdq(1:ngrid,1:nlayer,1:nq) + zdqmr(1:ngrid,1:nlayer,1:nq)
             dqsurf(1:ngrid,1:nq)       = dqsurf(1:ngrid,1:nq) + zdqsurfmr(1:ngrid,1:nq)
@@ -1217,5 +1281,5 @@
             pdpsrf(1:ngrid)            = pdpsrf(1:ngrid) + zdpsrfmr(1:ngrid)
             zdtsurf(1:ngrid)           = zdtsurf(1:ngrid) + zdtsurfmr(1:ngrid)
-            
+
          endif
 
@@ -1238,5 +1302,5 @@
          qsurf(1:ngrid,1:nq) = qsurf(1:ngrid,1:nq) + ptimestep*dqsurf(1:ngrid,1:nq)
 
-         ! Add qsurf to qsurf_hist, which is what we save in diagfi.nc. At the same time, we set the water 
+         ! Add qsurf to qsurf_hist, which is what we save in diagfi.nc. At the same time, we set the water
          ! content of ocean gridpoints back to zero, in order to avoid rounding errors in vdifc, rain.
          qsurf_hist(:,:) = qsurf(:,:)
@@ -1250,5 +1314,5 @@
 
 !------------------------------------------------
-!   VII. Surface and sub-surface soil temperature 
+!   VII. Surface and sub-surface soil temperature
 !------------------------------------------------
 
@@ -1256,19 +1320,19 @@
       ! ! Increment surface temperature
       ! if(ok_slab_ocean)then  !AF24: removed
-      
-      tsurf(1:ngrid)=tsurf(1:ngrid)+ptimestep*zdtsurf(1:ngrid) 
+
+      tsurf(1:ngrid)=tsurf(1:ngrid)+ptimestep*zdtsurf(1:ngrid)
 
       ! Compute soil temperatures and subsurface heat flux.
       if (callsoil) then
          call soil(ngrid,nsoilmx,.false.,lastcall,inertiedat,   &
-                   ptimestep,tsurf,tsoil,capcal,fluxgrd)     
+                   ptimestep,tsurf,tsoil,capcal,fluxgrd)
       endif
 
 
 !       if (ok_slab_ocean) then !AF24: removed
-      
+
       ! Test energy conservation
       if(enertest)then
-         call planetwide_sumval(cell_area(:)*capcal(:)*zdtsurf(:)/totarea_planet,dEtots)         
+         call planetwide_sumval(cell_area(:)*capcal(:)*zdtsurf(:)/totarea_planet,dEtots)
          if (is_master) print*,'Surface energy change                 =',dEtots,' W m-2'
       endif
